package de.jatitv.commandguiv2.Spigot.sound;

import de.jatitv.commandguiv2.Spigot.config.config.SelectConfig;
import de.jatitv.commandguiv2.Spigot.config.languages.SelectMessages;
import de.jatitv.commandguiv2.Spigot.objects.functions.Function;
import de.jatitv.commandguiv2.Spigot.objects.guis.Gui;
import de.jatitv.commandguiv2.Spigot.objects.slots.Slot;
import de.jatitv.commandguiv2.Spigot.enums.SoundEnum;
import de.jatitv.commandguiv2.Util;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.replace.Replace;
import org.bukkit.entity.Player;

public class Sound {
    private static String prefix = Util.getPrefix();

    public static void play(Player player, SoundEnum soundEnum) {
        if (!SelectConfig.getSound_Enable()) return;
        play(player, soundEnum, null, null, null);
    }

    public static void play(Player player, SoundEnum soundEnum, Function function, Slot slot, Gui gui) {
        if (!SelectConfig.getSound_Enable()) return;
        switch (soundEnum) {
            case OpenInventory:
                if (!SelectConfig.getSound_OpenInventory_Enable()) return;
                player.playSound(player.getLocation(), SelectConfig.getSound_OpenInventory(), 3, 1);
                break;
            case Click:
                if (!SelectConfig.getSound_Click_Enable()) return;
                if (!function.customSound_Enable) player.playSound(player.getLocation(), SelectConfig.getSound_Click(), 3, 1);

                if (function.customSound_NoSound) return;
                try {
                    player.playSound(player.getLocation(), org.bukkit.Sound.valueOf(function.customSound_Sound.toUpperCase().replace(".", "_")), 3, 1);
                } catch (Exception e1) {
                    send.console("§4\n§4\n§4\n" + SelectMessages.SoundNotFound.replace("[prefix]", prefix)
                            .replace("[sound]", "§6GUI: §e" + Replace.replace(prefix, gui.guiName) + "§r §6Slot: §e" + slot.slot + " §6CustomSound: §9" + function.customSound_Sound));
                    player.playSound(player.getLocation(), SelectConfig.getSound_Click(), 3, 1);
                }
                break;
            case NoMoney:
                if (!SelectConfig.getSound_NoMoney_Enable()) return;
                player.playSound(player.getLocation(), SelectConfig.getSound_NoMoney(), 3, 1);
                break;
            case NoInventorySpace:
                if (!SelectConfig.getSound_NoInventorySpace_Enable()) return;
                player.playSound(player.getLocation(), SelectConfig.getSound_NoInventorySpace(), 3, 1);
                break;
            case Give:
                if (!SelectConfig.getSound_Give_Enable()) return;
                player.playSound(player.getLocation(), SelectConfig.getSound_Give(), 3, 1);
                break;
            case PlayerNotFound:
                if (!SelectConfig.getSound_PlayerNotFound_Enable()) return;
                player.playSound(player.getLocation(), SelectConfig.getSound_PlayerNotFound(), 3, 1);
                break;
        }
    }
}
